/* iCalEntityObject+Utilities.m - this file is part of SOGo
 *
 * Copyright (C) 2007 Inverse inc.
 *
 * Author: Wolfgang Sourdeau <wsourdeau@inverse.ca>
 *
 * This file is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This file is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#import <Foundation/NSArray.h>
#import <Foundation/NSEnumerator.h>

#import <NGCards/iCalPerson.h>

#import "SOGoUser.h"

#import "iCalEntityObject+Utilities.h"

#warning we should move this into Appointments.

@implementation iCalEntityObject (SOGoAddition)

- (iCalPerson *) findParticipant: (SOGoUser *) user
{
  iCalPerson *participant, *currentParticipant;
  NSEnumerator *participants;

  participant = nil;
  participants = [[self attendees] objectEnumerator];
  currentParticipant = [participants nextObject];
  while (currentParticipant && !participant)
    if ([user hasEmail: [currentParticipant rfc822Email]])
      participant = currentParticipant;
    else
      currentParticipant = [participants nextObject];

  return participant;
}

@end
